Jonathan Nieder | c74c720 | 2013-11-25 13:03:06 -0800 | [diff] [blame] | 1 | # Test framework for git. See t/README for usage. |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 2 | # |
| 3 | # Copyright (c) 2005 Junio C Hamano |
| 4 | # |
Michal Sojka | 64b9032 | 2010-04-16 15:53:59 +0200 | [diff] [blame] | 5 | # This program is free software: you can redistribute it and/or modify |
| 6 | # it under the terms of the GNU General Public License as published by |
| 7 | # the Free Software Foundation, either version 2 of the License, or |
| 8 | # (at your option) any later version. |
| 9 | # |
| 10 | # This program is distributed in the hope that it will be useful, |
| 11 | # but WITHOUT ANY WARRANTY; without even the implied warranty of |
| 12 | # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the |
| 13 | # GNU General Public License for more details. |
| 14 | # |
| 15 | # You should have received a copy of the GNU General Public License |
| 16 | # along with this program. If not, see http://www.gnu.org/licenses/ . |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 17 | |
Junio C Hamano | c2116a1 | 2008-03-06 19:04:26 -0800 | [diff] [blame] | 18 | # Keep the original TERM for say_color |
| 19 | ORIGINAL_TERM=$TERM |
| 20 | |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 21 | # Test the binaries we have just built. The tests are kept in |
| 22 | # t/ subdirectory and are run in 'trash directory' subdirectory. |
| 23 | if test -z "$TEST_DIRECTORY" |
| 24 | then |
| 25 | # We allow tests to override this, in case they want to run tests |
| 26 | # outside of t/, e.g. for running tests on the test library |
| 27 | # itself. |
| 28 | TEST_DIRECTORY=$(pwd) |
Felipe Contreras | 85176d7 | 2013-11-17 23:12:43 -0500 | [diff] [blame] | 29 | else |
| 30 | # ensure that TEST_DIRECTORY is an absolute path so that it |
| 31 | # is valid even if the current working directory is changed |
| 32 | TEST_DIRECTORY=$(cd "$TEST_DIRECTORY" && pwd) || exit 1 |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 33 | fi |
| 34 | if test -z "$TEST_OUTPUT_DIRECTORY" |
| 35 | then |
| 36 | # Similarly, override this to store the test-results subdir |
| 37 | # elsewhere |
| 38 | TEST_OUTPUT_DIRECTORY=$TEST_DIRECTORY |
| 39 | fi |
| 40 | GIT_BUILD_DIR="$TEST_DIRECTORY"/.. |
| 41 | |
Ramkumar Ramachandra | 2006f0a | 2012-09-17 22:36:19 +0530 | [diff] [blame] | 42 | ################################################################ |
| 43 | # It appears that people try to run tests without building... |
| 44 | "$GIT_BUILD_DIR/git" >/dev/null |
| 45 | if test $? != 1 |
| 46 | then |
| 47 | echo >&2 'error: you do not seem to have built git yet.' |
| 48 | exit 1 |
| 49 | fi |
| 50 | |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 51 | . "$GIT_BUILD_DIR"/GIT-BUILD-OPTIONS |
| 52 | export PERL_PATH SHELL_PATH |
| 53 | |
Ramkumar Ramachandra | 4cde519 | 2012-09-22 10:25:10 +0530 | [diff] [blame] | 54 | # if --tee was passed, write the output not only to the terminal, but |
| 55 | # additionally to the file test-results/$BASENAME.out, too. |
| 56 | case "$GIT_TEST_TEE_STARTED, $* " in |
| 57 | done,*) |
| 58 | # do not redirect again |
| 59 | ;; |
| 60 | *' --tee '*|*' --va'*) |
John Keeping | 2d14e13 | 2013-04-29 19:16:21 +0100 | [diff] [blame] | 61 | mkdir -p "$TEST_OUTPUT_DIRECTORY/test-results" |
| 62 | BASE="$TEST_OUTPUT_DIRECTORY/test-results/$(basename "$0" .sh)" |
Ramkumar Ramachandra | 4cde519 | 2012-09-22 10:25:10 +0530 | [diff] [blame] | 63 | (GIT_TEST_TEE_STARTED=done ${SHELL_PATH} "$0" "$@" 2>&1; |
| 64 | echo $? > $BASE.exit) | tee $BASE.out |
| 65 | test "$(cat $BASE.exit)" = 0 |
| 66 | exit |
| 67 | ;; |
| 68 | esac |
| 69 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 70 | # For repeatability, reset the environment to known value. |
| 71 | LANG=C |
Junio C Hamano | 899460f | 2005-10-09 21:58:02 -0700 | [diff] [blame] | 72 | LC_ALL=C |
Pavel Roskin | d9bdd39 | 2005-08-10 22:10:01 -0400 | [diff] [blame] | 73 | PAGER=cat |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 74 | TZ=UTC |
Junio C Hamano | c2116a1 | 2008-03-06 19:04:26 -0800 | [diff] [blame] | 75 | TERM=dumb |
| 76 | export LANG LC_ALL PAGER TERM TZ |
Eric Wong | 8ff99e7 | 2006-07-11 12:01:54 -0700 | [diff] [blame] | 77 | EDITOR=: |
Stefano Lattarini | 661bfd1 | 2012-03-02 19:48:36 +0100 | [diff] [blame] | 78 | # A call to "unset" with no arguments causes at least Solaris 10 |
| 79 | # /usr/xpg4/bin/sh and /bin/ksh to bail out. So keep the unsets |
| 80 | # deriving from the command substitution clustered with the other |
| 81 | # ones. |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 82 | unset VISUAL EMAIL LANGUAGE COLUMNS $("$PERL_PATH" -e ' |
Jonathan Nieder | 95a1d12 | 2011-03-15 05:10:45 -0500 | [diff] [blame] | 83 | my @env = keys %ENV; |
Jens Lehmann | 730477f | 2011-03-28 21:16:09 +0200 | [diff] [blame] | 84 | my $ok = join("|", qw( |
| 85 | TRACE |
| 86 | DEBUG |
| 87 | USE_LOOKUP |
| 88 | TEST |
| 89 | .*_TEST |
| 90 | PROVE |
| 91 | VALGRIND |
René Scharfe | ac00128 | 2013-01-06 18:47:57 +0100 | [diff] [blame] | 92 | UNZIP |
Nguyễn Thái Ngọc Duy | edb5408 | 2013-01-15 20:50:56 +0700 | [diff] [blame] | 93 | PERF_ |
Jeff King | e2a0ccc | 2014-05-22 05:28:50 -0400 | [diff] [blame] | 94 | CURL_VERBOSE |
Jens Lehmann | 730477f | 2011-03-28 21:16:09 +0200 | [diff] [blame] | 95 | )); |
| 96 | my @vars = grep(/^GIT_/ && !/^GIT_($ok)/o, @env); |
Jonathan Nieder | 95a1d12 | 2011-03-15 05:10:45 -0500 | [diff] [blame] | 97 | print join("\n", @vars); |
| 98 | ') |
Jeff King | 5adf84e | 2012-07-24 07:53:05 -0400 | [diff] [blame] | 99 | unset XDG_CONFIG_HOME |
Benoit Person | 8bade1e | 2013-07-04 22:38:55 +0200 | [diff] [blame] | 100 | unset GITPERLLIB |
Junio C Hamano | 29e55cd | 2006-02-10 19:11:23 -0800 | [diff] [blame] | 101 | GIT_AUTHOR_EMAIL=author@example.com |
| 102 | GIT_AUTHOR_NAME='A U Thor' |
Junio C Hamano | 29e55cd | 2006-02-10 19:11:23 -0800 | [diff] [blame] | 103 | GIT_COMMITTER_EMAIL=committer@example.com |
| 104 | GIT_COMMITTER_NAME='C O Mitter' |
Shawn O. Pearce | 8d0fc48 | 2007-02-04 00:45:47 -0500 | [diff] [blame] | 105 | GIT_MERGE_VERBOSITY=5 |
Junio C Hamano | f824628 | 2012-01-10 22:44:45 -0800 | [diff] [blame] | 106 | GIT_MERGE_AUTOEDIT=no |
| 107 | export GIT_MERGE_VERBOSITY GIT_MERGE_AUTOEDIT |
Junio C Hamano | 29e55cd | 2006-02-10 19:11:23 -0800 | [diff] [blame] | 108 | export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME |
| 109 | export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME |
Jonathan Nieder | d33738d | 2009-11-11 17:56:07 -0600 | [diff] [blame] | 110 | export EDITOR |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 111 | |
Karsten Blees | 124647c | 2014-07-12 02:03:01 +0200 | [diff] [blame] | 112 | # Tests using GIT_TRACE typically don't want <timestamp> <file>:<line> output |
| 113 | GIT_TRACE_BARE=1 |
| 114 | export GIT_TRACE_BARE |
| 115 | |
Thomas Gummerer | 5d9fc88 | 2014-02-23 21:49:58 +0100 | [diff] [blame] | 116 | if test -n "${TEST_GIT_INDEX_VERSION:+isset}" |
| 117 | then |
| 118 | GIT_INDEX_VERSION="$TEST_GIT_INDEX_VERSION" |
| 119 | export GIT_INDEX_VERSION |
| 120 | fi |
| 121 | |
Elia Pinto | a731fa9 | 2012-09-14 09:54:22 -0700 | [diff] [blame] | 122 | # Add libc MALLOC and MALLOC_PERTURB test |
| 123 | # only if we are not executing the test with valgrind |
Junio C Hamano | 1b3185f | 2012-09-14 20:38:24 -0700 | [diff] [blame] | 124 | if expr " $GIT_TEST_OPTS " : ".* --valgrind " >/dev/null || |
René Scharfe | ee1431b | 2012-09-26 22:16:39 +0200 | [diff] [blame] | 125 | test -n "$TEST_NO_MALLOC_CHECK" |
Junio C Hamano | 1b3185f | 2012-09-14 20:38:24 -0700 | [diff] [blame] | 126 | then |
| 127 | setup_malloc_check () { |
| 128 | : nothing |
| 129 | } |
| 130 | teardown_malloc_check () { |
| 131 | : nothing |
| 132 | } |
| 133 | else |
| 134 | setup_malloc_check () { |
| 135 | MALLOC_CHECK_=3 MALLOC_PERTURB_=165 |
| 136 | export MALLOC_CHECK_ MALLOC_PERTURB_ |
| 137 | } |
| 138 | teardown_malloc_check () { |
| 139 | unset MALLOC_CHECK_ MALLOC_PERTURB_ |
| 140 | } |
| 141 | fi |
Elia Pinto | a731fa9 | 2012-09-14 09:54:22 -0700 | [diff] [blame] | 142 | |
Junio C Hamano | 886a390 | 2007-04-24 11:21:47 -0700 | [diff] [blame] | 143 | # Protect ourselves from common misconfiguration to export |
| 144 | # CDPATH into the environment |
| 145 | unset CDPATH |
| 146 | |
Bert Wesarg | 5565f47 | 2009-11-18 17:15:19 +0100 | [diff] [blame] | 147 | unset GREP_OPTIONS |
René Scharfe | ac00128 | 2013-01-06 18:47:57 +0100 | [diff] [blame] | 148 | unset UNZIP |
Bert Wesarg | 5565f47 | 2009-11-18 17:15:19 +0100 | [diff] [blame] | 149 | |
Robin Rosenberg | 3d5c0cc | 2006-09-23 00:35:20 +0200 | [diff] [blame] | 150 | case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 151 | 1|2|true) |
| 152 | echo "* warning: Some tests will not work if GIT_TRACE" \ |
| 153 | "is set as to trace on STDERR ! *" |
| 154 | echo "* warning: Please set GIT_TRACE to something" \ |
| 155 | "other than 1, 2 or true ! *" |
| 156 | ;; |
Christian Couder | 6ce4e61 | 2006-09-02 18:23:48 +0200 | [diff] [blame] | 157 | esac |
| 158 | |
Junio C Hamano | cd3c095 | 2009-09-20 11:10:14 -0700 | [diff] [blame] | 159 | # Convenience |
| 160 | # |
| 161 | # A regexp to match 5 and 40 hexdigits |
| 162 | _x05='[0-9a-f][0-9a-f][0-9a-f][0-9a-f][0-9a-f]' |
| 163 | _x40="$_x05$_x05$_x05$_x05$_x05$_x05$_x05$_x05" |
| 164 | |
Junio C Hamano | 3749fde | 2011-04-23 22:34:13 -0700 | [diff] [blame] | 165 | # Zero SHA-1 |
| 166 | _z40=0000000000000000000000000000000000000000 |
| 167 | |
Junio C Hamano | 3f4ab62 | 2011-08-08 11:51:00 -0700 | [diff] [blame] | 168 | # Line feed |
| 169 | LF=' |
| 170 | ' |
| 171 | |
Jeff King | a42643a | 2014-12-15 18:15:20 -0500 | [diff] [blame] | 172 | # UTF-8 ZERO WIDTH NON-JOINER, which HFS+ ignores |
| 173 | # when case-folding filenames |
| 174 | u200c=$(printf '\342\200\214') |
| 175 | |
| 176 | export _x05 _x40 _z40 LF u200c |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 177 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 178 | # Each test should start with something like this, after copyright notices: |
| 179 | # |
| 180 | # test_description='Description of this test... |
| 181 | # This test checks if command xyzzy does the right thing... |
| 182 | # ' |
| 183 | # . ./test-lib.sh |
Junio C Hamano | c2116a1 | 2008-03-06 19:04:26 -0800 | [diff] [blame] | 184 | [ "x$ORIGINAL_TERM" != "xdumb" ] && ( |
| 185 | TERM=$ORIGINAL_TERM && |
| 186 | export TERM && |
| 187 | [ -t 1 ] && |
| 188 | tput bold >/dev/null 2>&1 && |
| 189 | tput setaf 1 >/dev/null 2>&1 && |
| 190 | tput sgr0 >/dev/null 2>&1 |
| 191 | ) && |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 192 | color=t |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 193 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 194 | while test "$#" -ne 0 |
| 195 | do |
| 196 | case "$1" in |
| 197 | -d|--d|--de|--deb|--debu|--debug) |
| 198 | debug=t; shift ;; |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 199 | -i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate) |
| 200 | immediate=t; shift ;; |
Lea Wiemann | 5e2c08c | 2008-06-17 03:29:02 +0200 | [diff] [blame] | 201 | -l|--l|--lo|--lon|--long|--long-|--long-t|--long-te|--long-tes|--long-test|--long-tests) |
Junio C Hamano | 91e80b9 | 2009-02-18 11:17:27 -0800 | [diff] [blame] | 202 | GIT_TEST_LONG=t; export GIT_TEST_LONG; shift ;; |
Ilya Bobyr | 0445e6f | 2014-04-30 02:50:44 -0700 | [diff] [blame] | 203 | -r) |
| 204 | shift; test "$#" -ne 0 || { |
| 205 | echo 'error: -r requires an argument' >&2; |
| 206 | exit 1; |
| 207 | } |
| 208 | run_list=$1; shift ;; |
| 209 | --run=*) |
| 210 | run_list=$(expr "z$1" : 'z[^=]*=\(.*\)'); shift ;; |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 211 | -h|--h|--he|--hel|--help) |
Michele Ballabio | 570f322 | 2007-11-10 15:17:25 +0100 | [diff] [blame] | 212 | help=t; shift ;; |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 213 | -v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose) |
| 214 | verbose=t; shift ;; |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 215 | --verbose-only=*) |
| 216 | verbose_only=$(expr "z$1" : 'z[^=]*=\(.*\)') |
| 217 | shift ;; |
Pierre Habouzit | 1ece127 | 2007-10-24 22:03:39 +0200 | [diff] [blame] | 218 | -q|--q|--qu|--qui|--quie|--quiet) |
Ævar Arnfjörð Bjarmason | 092c433 | 2010-07-31 16:40:05 +0000 | [diff] [blame] | 219 | # Ignore --quiet under a TAP::Harness. Saying how many tests |
| 220 | # passed without the ok/not ok details is always an error. |
| 221 | test -z "$HARNESS_ACTIVE" && quiet=t; shift ;; |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 222 | --with-dashes) |
| 223 | with_dashes=t; shift ;; |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 224 | --no-color) |
Clemens Buchacher | faa4bc3 | 2008-02-27 20:28:45 +0100 | [diff] [blame] | 225 | color=; shift ;; |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 226 | --va|--val|--valg|--valgr|--valgri|--valgrin|--valgrind) |
Thomas Rast | 952af35 | 2013-03-31 10:00:16 +0200 | [diff] [blame] | 227 | valgrind=memcheck |
| 228 | shift ;; |
| 229 | --valgrind=*) |
| 230 | valgrind=$(expr "z$1" : 'z[^=]*=\(.*\)') |
| 231 | shift ;; |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 232 | --valgrind-only=*) |
| 233 | valgrind_only=$(expr "z$1" : 'z[^=]*=\(.*\)') |
| 234 | shift ;; |
Johannes Schindelin | 4413855 | 2009-02-04 00:26:12 +0100 | [diff] [blame] | 235 | --tee) |
| 236 | shift ;; # was handled already |
Jeff King | f423ef5 | 2009-08-09 04:39:45 -0400 | [diff] [blame] | 237 | --root=*) |
| 238 | root=$(expr "z$1" : 'z[^=]*=\(.*\)') |
| 239 | shift ;; |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 240 | *) |
Clemens Buchacher | 1f729dc | 2009-06-01 14:14:40 +0200 | [diff] [blame] | 241 | echo "error: unknown test option '$1'" >&2; exit 1 ;; |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 242 | esac |
| 243 | done |
| 244 | |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 245 | if test -n "$valgrind_only" |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 246 | then |
| 247 | test -z "$valgrind" && valgrind=memcheck |
| 248 | test -z "$verbose" && verbose_only="$valgrind_only" |
| 249 | elif test -n "$valgrind" |
| 250 | then |
| 251 | verbose=t |
| 252 | fi |
Thomas Rast | 952af35 | 2013-03-31 10:00:16 +0200 | [diff] [blame] | 253 | |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 254 | if test -n "$color" |
| 255 | then |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 256 | say_color () { |
Junio C Hamano | c2116a1 | 2008-03-06 19:04:26 -0800 | [diff] [blame] | 257 | ( |
| 258 | TERM=$ORIGINAL_TERM |
| 259 | export TERM |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 260 | case "$1" in |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 261 | error) |
| 262 | tput bold; tput setaf 1;; # bold red |
| 263 | skip) |
Adam Spiers | b8fc855 | 2012-12-16 18:28:11 +0000 | [diff] [blame] | 264 | tput setaf 4;; # blue |
Adam Spiers | e8e5195 | 2012-12-16 18:28:10 +0000 | [diff] [blame] | 265 | warn) |
| 266 | tput setaf 3;; # brown/yellow |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 267 | pass) |
Adam Spiers | 0a6d475 | 2012-12-16 18:28:12 +0000 | [diff] [blame] | 268 | tput setaf 2;; # green |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 269 | info) |
Adam Spiers | 0a6d475 | 2012-12-16 18:28:12 +0000 | [diff] [blame] | 270 | tput setaf 6;; # cyan |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 271 | *) |
| 272 | test -n "$quiet" && return;; |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 273 | esac |
| 274 | shift |
Ævar Arnfjörð Bjarmason | 5099b99 | 2010-06-24 21:52:12 +0000 | [diff] [blame] | 275 | printf "%s" "$*" |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 276 | tput sgr0 |
Miklos Vajna | b8eecaf | 2008-10-10 00:07:10 +0200 | [diff] [blame] | 277 | echo |
Junio C Hamano | c2116a1 | 2008-03-06 19:04:26 -0800 | [diff] [blame] | 278 | ) |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 279 | } |
| 280 | else |
| 281 | say_color() { |
Pierre Habouzit | 1ece127 | 2007-10-24 22:03:39 +0200 | [diff] [blame] | 282 | test -z "$1" && test -n "$quiet" && return |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 283 | shift |
Junio C Hamano | 7bc0911 | 2012-10-11 10:40:36 -0700 | [diff] [blame] | 284 | printf "%s\n" "$*" |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 285 | } |
| 286 | fi |
| 287 | |
| 288 | error () { |
| 289 | say_color error "error: $*" |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 290 | GIT_EXIT_OK=t |
Pierre Habouzit | 55db1df | 2007-10-24 22:03:38 +0200 | [diff] [blame] | 291 | exit 1 |
| 292 | } |
| 293 | |
| 294 | say () { |
| 295 | say_color info "$*" |
| 296 | } |
| 297 | |
Michele Ballabio | 570f322 | 2007-11-10 15:17:25 +0100 | [diff] [blame] | 298 | test "${test_description}" != "" || |
| 299 | error "Test script did not set test_description." |
| 300 | |
| 301 | if test "$help" = "t" |
| 302 | then |
Uwe Storbeck | cb1aefd | 2014-03-18 01:14:11 +0100 | [diff] [blame] | 303 | printf '%s\n' "$test_description" |
Michele Ballabio | 570f322 | 2007-11-10 15:17:25 +0100 | [diff] [blame] | 304 | exit 0 |
| 305 | fi |
| 306 | |
Pavel Roskin | 4d9d62f | 2005-08-10 23:56:21 -0400 | [diff] [blame] | 307 | exec 5>&1 |
Jeff King | 781f76b | 2011-12-15 01:55:29 -0500 | [diff] [blame] | 308 | exec 6<&0 |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 309 | if test "$verbose" = "t" |
| 310 | then |
| 311 | exec 4>&2 3>&1 |
| 312 | else |
| 313 | exec 4>/dev/null 3>/dev/null |
| 314 | fi |
| 315 | |
| 316 | test_failure=0 |
| 317 | test_count=0 |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 318 | test_fixed=0 |
| 319 | test_broken=0 |
Sverre Rabbelier | 2d84e9f | 2008-06-08 16:04:33 +0200 | [diff] [blame] | 320 | test_success=0 |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 321 | |
Ævar Arnfjörð Bjarmason | d998bd4 | 2010-06-24 17:44:46 +0000 | [diff] [blame] | 322 | test_external_has_tap=0 |
| 323 | |
Clemens Buchacher | faa4bc3 | 2008-02-27 20:28:45 +0100 | [diff] [blame] | 324 | die () { |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 325 | code=$? |
| 326 | if test -n "$GIT_EXIT_OK" |
| 327 | then |
| 328 | exit $code |
| 329 | else |
| 330 | echo >&5 "FATAL: Unexpected exit with code $code" |
| 331 | exit 1 |
| 332 | fi |
Clemens Buchacher | faa4bc3 | 2008-02-27 20:28:45 +0100 | [diff] [blame] | 333 | } |
| 334 | |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 335 | GIT_EXIT_OK= |
Markus Heidelberg | 3564131 | 2009-01-20 00:43:26 +0100 | [diff] [blame] | 336 | trap 'die' EXIT |
Pavel Roskin | 4118427 | 2005-08-11 12:00:40 -0400 | [diff] [blame] | 337 | |
Thomas Rast | 12a29b1 | 2012-02-17 11:25:08 +0100 | [diff] [blame] | 338 | # The user-facing functions are loaded from a separate file so that |
| 339 | # test_perf subshells can have them too |
Junio C Hamano | 3c8f12c | 2012-06-24 22:01:35 -0700 | [diff] [blame] | 340 | . "$TEST_DIRECTORY/test-lib-functions.sh" |
Jonathan Nieder | 05236a5 | 2010-10-17 02:36:58 +0800 | [diff] [blame] | 341 | |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 342 | # You are not expected to call test_ok_ and test_failure_ directly, use |
Torstein Hegge | 3fa3666 | 2013-10-27 10:56:33 +0100 | [diff] [blame] | 343 | # the test_expect_* functions instead. |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 344 | |
| 345 | test_ok_ () { |
Johannes Sixt | d5d9de1 | 2009-02-05 20:59:27 +0100 | [diff] [blame] | 346 | test_success=$(($test_success + 1)) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 347 | say_color "" "ok $test_count - $@" |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 348 | } |
| 349 | |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 350 | test_failure_ () { |
Johannes Sixt | d5d9de1 | 2009-02-05 20:59:27 +0100 | [diff] [blame] | 351 | test_failure=$(($test_failure + 1)) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 352 | say_color error "not ok $test_count - $1" |
Junio C Hamano | bf0dd8a | 2005-07-22 19:09:34 -0700 | [diff] [blame] | 353 | shift |
Uwe Storbeck | cb1aefd | 2014-03-18 01:14:11 +0100 | [diff] [blame] | 354 | printf '%s\n' "$*" | sed -e 's/^/# /' |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 355 | test "$immediate" = "" || { GIT_EXIT_OK=t; exit 1; } |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 356 | } |
| 357 | |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 358 | test_known_broken_ok_ () { |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 359 | test_fixed=$(($test_fixed+1)) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 360 | say_color error "ok $test_count - $@ # TODO known breakage vanished" |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 361 | } |
| 362 | |
| 363 | test_known_broken_failure_ () { |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 364 | test_broken=$(($test_broken+1)) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 365 | say_color warn "not ok $test_count - $@ # TODO known breakage" |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 366 | } |
Junio C Hamano | 886856a | 2005-05-14 00:24:27 -0700 | [diff] [blame] | 367 | |
| 368 | test_debug () { |
Junio C Hamano | 8e832eb | 2005-08-10 22:53:27 -0700 | [diff] [blame] | 369 | test "$debug" = "" || eval "$1" |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 370 | } |
| 371 | |
Thomas Rast | e6a6ddc | 2013-06-18 14:25:58 +0200 | [diff] [blame] | 372 | match_pattern_list () { |
| 373 | arg="$1" |
| 374 | shift |
| 375 | test -z "$*" && return 1 |
| 376 | for pattern_ |
| 377 | do |
| 378 | case "$arg" in |
| 379 | $pattern_) |
| 380 | return 0 |
| 381 | esac |
| 382 | done |
| 383 | return 1 |
| 384 | } |
| 385 | |
Ilya Bobyr | 0445e6f | 2014-04-30 02:50:44 -0700 | [diff] [blame] | 386 | match_test_selector_list () { |
| 387 | title="$1" |
| 388 | shift |
| 389 | arg="$1" |
| 390 | shift |
| 391 | test -z "$1" && return 0 |
| 392 | |
| 393 | # Both commas and whitespace are accepted as separators. |
| 394 | OLDIFS=$IFS |
| 395 | IFS=' ,' |
| 396 | set -- $1 |
| 397 | IFS=$OLDIFS |
| 398 | |
| 399 | # If the first selector is negative we include by default. |
| 400 | include= |
| 401 | case "$1" in |
| 402 | !*) include=t ;; |
| 403 | esac |
| 404 | |
| 405 | for selector |
| 406 | do |
| 407 | orig_selector=$selector |
| 408 | |
| 409 | positive=t |
| 410 | case "$selector" in |
| 411 | !*) |
| 412 | positive= |
| 413 | selector=${selector##?} |
| 414 | ;; |
| 415 | esac |
| 416 | |
| 417 | test -z "$selector" && continue |
| 418 | |
| 419 | case "$selector" in |
| 420 | *-*) |
| 421 | if expr "z${selector%%-*}" : "z[0-9]*[^0-9]" >/dev/null |
| 422 | then |
| 423 | echo "error: $title: invalid non-numeric in range" \ |
| 424 | "start: '$orig_selector'" >&2 |
| 425 | exit 1 |
| 426 | fi |
| 427 | if expr "z${selector#*-}" : "z[0-9]*[^0-9]" >/dev/null |
| 428 | then |
| 429 | echo "error: $title: invalid non-numeric in range" \ |
| 430 | "end: '$orig_selector'" >&2 |
| 431 | exit 1 |
| 432 | fi |
| 433 | ;; |
| 434 | *) |
| 435 | if expr "z$selector" : "z[0-9]*[^0-9]" >/dev/null |
| 436 | then |
| 437 | echo "error: $title: invalid non-numeric in test" \ |
| 438 | "selector: '$orig_selector'" >&2 |
| 439 | exit 1 |
| 440 | fi |
| 441 | esac |
| 442 | |
| 443 | # Short cut for "obvious" cases |
| 444 | test -z "$include" && test -z "$positive" && continue |
| 445 | test -n "$include" && test -n "$positive" && continue |
| 446 | |
| 447 | case "$selector" in |
| 448 | -*) |
| 449 | if test $arg -le ${selector#-} |
| 450 | then |
| 451 | include=$positive |
| 452 | fi |
| 453 | ;; |
| 454 | *-) |
| 455 | if test $arg -ge ${selector%-} |
| 456 | then |
| 457 | include=$positive |
| 458 | fi |
| 459 | ;; |
| 460 | *-*) |
| 461 | if test ${selector%%-*} -le $arg \ |
| 462 | && test $arg -le ${selector#*-} |
| 463 | then |
| 464 | include=$positive |
| 465 | fi |
| 466 | ;; |
| 467 | *) |
| 468 | if test $arg -eq $selector |
| 469 | then |
| 470 | include=$positive |
| 471 | fi |
| 472 | ;; |
| 473 | esac |
| 474 | done |
| 475 | |
| 476 | test -n "$include" |
| 477 | } |
| 478 | |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 479 | maybe_teardown_verbose () { |
| 480 | test -z "$verbose_only" && return |
| 481 | exec 4>/dev/null 3>/dev/null |
| 482 | verbose= |
| 483 | } |
| 484 | |
| 485 | last_verbose=t |
| 486 | maybe_setup_verbose () { |
| 487 | test -z "$verbose_only" && return |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 488 | if match_pattern_list $test_count $verbose_only |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 489 | then |
| 490 | exec 4>&2 3>&1 |
| 491 | # Emit a delimiting blank line when going from |
| 492 | # non-verbose to verbose. Within verbose mode the |
| 493 | # delimiter is printed by test_expect_*. The choice |
| 494 | # of the initial $last_verbose is such that before |
| 495 | # test 1, we do not print it. |
| 496 | test -z "$last_verbose" && echo >&3 "" |
| 497 | verbose=t |
| 498 | else |
| 499 | exec 4>/dev/null 3>/dev/null |
| 500 | verbose= |
| 501 | fi |
| 502 | last_verbose=$verbose |
| 503 | } |
| 504 | |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 505 | maybe_teardown_valgrind () { |
| 506 | test -z "$GIT_VALGRIND" && return |
| 507 | GIT_VALGRIND_ENABLED= |
| 508 | } |
| 509 | |
| 510 | maybe_setup_valgrind () { |
| 511 | test -z "$GIT_VALGRIND" && return |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 512 | if test -z "$valgrind_only" |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 513 | then |
| 514 | GIT_VALGRIND_ENABLED=t |
| 515 | return |
| 516 | fi |
| 517 | GIT_VALGRIND_ENABLED= |
| 518 | if match_pattern_list $test_count $valgrind_only |
| 519 | then |
| 520 | GIT_VALGRIND_ENABLED=t |
| 521 | fi |
| 522 | } |
| 523 | |
Jonathan Nieder | a7c58f2 | 2011-08-08 03:17:09 +0200 | [diff] [blame] | 524 | test_eval_ () { |
| 525 | # This is a separate function because some tests use |
| 526 | # "return" to end a test_expect_success block early. |
Jeff King | 781f76b | 2011-12-15 01:55:29 -0500 | [diff] [blame] | 527 | eval </dev/null >&3 2>&4 "$*" |
Jonathan Nieder | a7c58f2 | 2011-08-08 03:17:09 +0200 | [diff] [blame] | 528 | } |
| 529 | |
Pavel Roskin | 4d9d62f | 2005-08-10 23:56:21 -0400 | [diff] [blame] | 530 | test_run_ () { |
Jonathan Nieder | b6b0afd | 2010-05-06 03:41:10 -0500 | [diff] [blame] | 531 | test_cleanup=: |
Junio C Hamano | b586744 | 2011-06-27 11:02:22 -0700 | [diff] [blame] | 532 | expecting_failure=$2 |
Thomas Rast | a57397b | 2013-06-17 11:18:46 +0200 | [diff] [blame] | 533 | setup_malloc_check |
Jonathan Nieder | a7c58f2 | 2011-08-08 03:17:09 +0200 | [diff] [blame] | 534 | test_eval_ "$1" |
Jonathan Nieder | b6b0afd | 2010-05-06 03:41:10 -0500 | [diff] [blame] | 535 | eval_ret=$? |
Thomas Rast | a57397b | 2013-06-17 11:18:46 +0200 | [diff] [blame] | 536 | teardown_malloc_check |
Junio C Hamano | b586744 | 2011-06-27 11:02:22 -0700 | [diff] [blame] | 537 | |
| 538 | if test -z "$immediate" || test $eval_ret = 0 || test -n "$expecting_failure" |
| 539 | then |
Junio C Hamano | 1b3185f | 2012-09-14 20:38:24 -0700 | [diff] [blame] | 540 | setup_malloc_check |
Jonathan Nieder | a7c58f2 | 2011-08-08 03:17:09 +0200 | [diff] [blame] | 541 | test_eval_ "$test_cleanup" |
Junio C Hamano | 1b3185f | 2012-09-14 20:38:24 -0700 | [diff] [blame] | 542 | teardown_malloc_check |
Junio C Hamano | b586744 | 2011-06-27 11:02:22 -0700 | [diff] [blame] | 543 | fi |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 544 | if test "$verbose" = "t" && test -n "$HARNESS_ACTIVE" |
| 545 | then |
Ævar Arnfjörð Bjarmason | 57e1538 | 2010-06-24 17:44:47 +0000 | [diff] [blame] | 546 | echo "" |
| 547 | fi |
Jonathan Nieder | aa0bcf9 | 2011-08-08 03:15:34 +0200 | [diff] [blame] | 548 | return "$eval_ret" |
Pavel Roskin | 4d9d62f | 2005-08-10 23:56:21 -0400 | [diff] [blame] | 549 | } |
| 550 | |
Thomas Rast | ae75342 | 2013-06-18 14:25:59 +0200 | [diff] [blame] | 551 | test_start_ () { |
Johannes Sixt | 8586f98 | 2009-02-05 21:20:56 +0100 | [diff] [blame] | 552 | test_count=$(($test_count+1)) |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 553 | maybe_setup_verbose |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 554 | maybe_setup_valgrind |
Thomas Rast | ae75342 | 2013-06-18 14:25:59 +0200 | [diff] [blame] | 555 | } |
| 556 | |
| 557 | test_finish_ () { |
| 558 | echo >&3 "" |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 559 | maybe_teardown_valgrind |
Thomas Rast | ff09af3 | 2013-06-23 20:12:56 +0200 | [diff] [blame] | 560 | maybe_teardown_verbose |
Thomas Rast | ae75342 | 2013-06-18 14:25:59 +0200 | [diff] [blame] | 561 | } |
| 562 | |
| 563 | test_skip () { |
Junio C Hamano | 04ece59 | 2006-12-28 17:58:00 -0800 | [diff] [blame] | 564 | to_skip= |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 565 | skipped_reason= |
Thomas Rast | e6a6ddc | 2013-06-18 14:25:58 +0200 | [diff] [blame] | 566 | if match_pattern_list $this_test.$test_count $GIT_SKIP_TESTS |
| 567 | then |
| 568 | to_skip=t |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 569 | skipped_reason="GIT_SKIP_TESTS" |
Thomas Rast | e6a6ddc | 2013-06-18 14:25:58 +0200 | [diff] [blame] | 570 | fi |
Jonathan Nieder | 05236a5 | 2010-10-17 02:36:58 +0800 | [diff] [blame] | 571 | if test -z "$to_skip" && test -n "$test_prereq" && |
| 572 | ! test_have_prereq "$test_prereq" |
Johannes Sixt | a7bb394 | 2009-03-01 21:04:46 +0100 | [diff] [blame] | 573 | then |
| 574 | to_skip=t |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 575 | |
Jonathan Nieder | 07431fc | 2010-08-24 02:34:10 -0500 | [diff] [blame] | 576 | of_prereq= |
Jonathan Nieder | 05236a5 | 2010-10-17 02:36:58 +0800 | [diff] [blame] | 577 | if test "$missing_prereq" != "$test_prereq" |
Jonathan Nieder | 07431fc | 2010-08-24 02:34:10 -0500 | [diff] [blame] | 578 | then |
Jonathan Nieder | 05236a5 | 2010-10-17 02:36:58 +0800 | [diff] [blame] | 579 | of_prereq=" of $test_prereq" |
Jonathan Nieder | 07431fc | 2010-08-24 02:34:10 -0500 | [diff] [blame] | 580 | fi |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 581 | skipped_reason="missing $missing_prereq${of_prereq}" |
| 582 | fi |
Ilya Bobyr | 0445e6f | 2014-04-30 02:50:44 -0700 | [diff] [blame] | 583 | if test -z "$to_skip" && test -n "$run_list" && |
| 584 | ! match_test_selector_list '--run' $test_count "$run_list" |
| 585 | then |
| 586 | to_skip=t |
| 587 | skipped_reason="--run" |
| 588 | fi |
Jonathan Nieder | 07431fc | 2010-08-24 02:34:10 -0500 | [diff] [blame] | 589 | |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 590 | case "$to_skip" in |
| 591 | t) |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 592 | say_color skip >&3 "skipping test: $@" |
Ilya Bobyr | ef2ac68 | 2014-04-30 02:50:43 -0700 | [diff] [blame] | 593 | say_color skip "ok $test_count # skip $1 ($skipped_reason)" |
Junio C Hamano | 04ece59 | 2006-12-28 17:58:00 -0800 | [diff] [blame] | 594 | : true |
| 595 | ;; |
| 596 | *) |
| 597 | false |
| 598 | ;; |
| 599 | esac |
| 600 | } |
| 601 | |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 602 | # stub; perf-lib overrides it |
| 603 | test_at_end_hook_ () { |
| 604 | : |
| 605 | } |
| 606 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 607 | test_done () { |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 608 | GIT_EXIT_OK=t |
Sverre Rabbelier | 2d84e9f | 2008-06-08 16:04:33 +0200 | [diff] [blame] | 609 | |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 610 | if test -z "$HARNESS_ACTIVE" |
| 611 | then |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 612 | test_results_dir="$TEST_OUTPUT_DIRECTORY/test-results" |
Ævar Arnfjörð Bjarmason | 8ef1abe | 2010-08-11 19:37:31 +0000 | [diff] [blame] | 613 | mkdir -p "$test_results_dir" |
Felipe Contreras | dd78478 | 2012-11-04 03:13:33 +0100 | [diff] [blame] | 614 | base=${0##*/} |
| 615 | test_results_path="$test_results_dir/${base%.sh}-$$.counts" |
Ævar Arnfjörð Bjarmason | 8ef1abe | 2010-08-11 19:37:31 +0000 | [diff] [blame] | 616 | |
Mathias Lafeldt | c54e6be | 2011-04-29 14:30:30 +0200 | [diff] [blame] | 617 | cat >>"$test_results_path" <<-EOF |
| 618 | total $test_count |
| 619 | success $test_success |
| 620 | fixed $test_fixed |
| 621 | broken $test_broken |
| 622 | failed $test_failure |
| 623 | |
| 624 | EOF |
Ævar Arnfjörð Bjarmason | 8ef1abe | 2010-08-11 19:37:31 +0000 | [diff] [blame] | 625 | fi |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 626 | |
| 627 | if test "$test_fixed" != 0 |
| 628 | then |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 629 | say_color error "# $test_fixed known breakage(s) vanished; please update test(s)" |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 630 | fi |
| 631 | if test "$test_broken" != 0 |
| 632 | then |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 633 | say_color warn "# still have $test_broken known breakage(s)" |
Adam Spiers | b73d9a2 | 2012-12-16 18:28:15 +0000 | [diff] [blame] | 634 | fi |
| 635 | if test "$test_broken" != 0 || test "$test_fixed" != 0 |
| 636 | then |
| 637 | test_remaining=$(( $test_count - $test_broken - $test_fixed )) |
| 638 | msg="remaining $test_remaining test(s)" |
Junio C Hamano | 11d54b8 | 2008-02-03 00:23:02 -0800 | [diff] [blame] | 639 | else |
Adam Spiers | b73d9a2 | 2012-12-16 18:28:15 +0000 | [diff] [blame] | 640 | test_remaining=$test_count |
Junio C Hamano | 11d54b8 | 2008-02-03 00:23:02 -0800 | [diff] [blame] | 641 | msg="$test_count test(s)" |
Junio C Hamano | 41ac414 | 2008-02-01 01:50:53 -0800 | [diff] [blame] | 642 | fi |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 643 | case "$test_failure" in |
Junio C Hamano | 10b94e2 | 2005-12-09 17:32:18 -0800 | [diff] [blame] | 644 | 0) |
Ævar Arnfjörð Bjarmason | 5099b99 | 2010-06-24 21:52:12 +0000 | [diff] [blame] | 645 | # Maybe print SKIP message |
Ramsay Jones | bf4b721 | 2012-09-01 19:13:19 +0100 | [diff] [blame] | 646 | if test -n "$skip_all" && test $test_count -gt 0 |
| 647 | then |
| 648 | error "Can't use skip_all after running some tests" |
| 649 | fi |
Ævar Arnfjörð Bjarmason | 5099b99 | 2010-06-24 21:52:12 +0000 | [diff] [blame] | 650 | [ -z "$skip_all" ] || skip_all=" # SKIP $skip_all" |
| 651 | |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 652 | if test $test_external_has_tap -eq 0 |
| 653 | then |
Adam Spiers | b73d9a2 | 2012-12-16 18:28:15 +0000 | [diff] [blame] | 654 | if test $test_remaining -gt 0 |
Ramsay Jones | d87bd7c | 2012-09-01 19:26:21 +0100 | [diff] [blame] | 655 | then |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 656 | say_color pass "# passed all $msg" |
Ramsay Jones | d87bd7c | 2012-09-01 19:26:21 +0100 | [diff] [blame] | 657 | fi |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 658 | say "1..$test_count$skip_all" |
Ævar Arnfjörð Bjarmason | d998bd4 | 2010-06-24 17:44:46 +0000 | [diff] [blame] | 659 | fi |
Johannes Schindelin | abc5d37 | 2008-08-08 13:08:37 +0200 | [diff] [blame] | 660 | |
| 661 | test -d "$remove_trash" && |
| 662 | cd "$(dirname "$remove_trash")" && |
| 663 | rm -rf "$(basename "$remove_trash")" |
| 664 | |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 665 | test_at_end_hook_ |
| 666 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 667 | exit 0 ;; |
| 668 | |
| 669 | *) |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 670 | if test $test_external_has_tap -eq 0 |
| 671 | then |
Thomas Rast | 633fe50 | 2013-10-19 23:06:08 +0200 | [diff] [blame] | 672 | say_color error "# failed $test_failure among $msg" |
| 673 | say "1..$test_count" |
Ævar Arnfjörð Bjarmason | d998bd4 | 2010-06-24 17:44:46 +0000 | [diff] [blame] | 674 | fi |
Ævar Arnfjörð Bjarmason | 5099b99 | 2010-06-24 21:52:12 +0000 | [diff] [blame] | 675 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 676 | exit 1 ;; |
| 677 | |
| 678 | esac |
| 679 | } |
| 680 | |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 681 | if test -n "$valgrind" |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 682 | then |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 683 | make_symlink () { |
| 684 | test -h "$2" && |
| 685 | test "$1" = "$(readlink "$2")" || { |
| 686 | # be super paranoid |
| 687 | if mkdir "$2".lock |
| 688 | then |
| 689 | rm -f "$2" && |
| 690 | ln -s "$1" "$2" && |
| 691 | rm -r "$2".lock |
| 692 | else |
| 693 | while test -d "$2".lock |
| 694 | do |
| 695 | say "Waiting for lock on $2." |
| 696 | sleep 1 |
| 697 | done |
| 698 | fi |
| 699 | } |
| 700 | } |
| 701 | |
| 702 | make_valgrind_symlink () { |
Jeff King | 36bfb0e | 2011-06-17 16:36:32 -0400 | [diff] [blame] | 703 | # handle only executables, unless they are shell libraries that |
Jonathan Nieder | 11d6214 | 2013-11-25 13:03:52 -0800 | [diff] [blame] | 704 | # need to be in the exec-path. |
Jeff King | 36bfb0e | 2011-06-17 16:36:32 -0400 | [diff] [blame] | 705 | test -x "$1" || |
Jonathan Nieder | 11d6214 | 2013-11-25 13:03:52 -0800 | [diff] [blame] | 706 | test "# " = "$(head -c 2 <"$1")" || |
Jeff King | 36bfb0e | 2011-06-17 16:36:32 -0400 | [diff] [blame] | 707 | return; |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 708 | |
| 709 | base=$(basename "$1") |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 710 | symlink_target=$GIT_BUILD_DIR/$base |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 711 | # do not override scripts |
| 712 | if test -x "$symlink_target" && |
| 713 | test ! -d "$symlink_target" && |
| 714 | test "#!" != "$(head -c 2 < "$symlink_target")" |
| 715 | then |
| 716 | symlink_target=../valgrind.sh |
| 717 | fi |
Johannes Schindelin | efd92ff | 2009-02-04 00:26:08 +0100 | [diff] [blame] | 718 | case "$base" in |
| 719 | *.sh|*.perl) |
| 720 | symlink_target=../unprocessed-script |
| 721 | esac |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 722 | # create the link, or replace it if it is out of date |
| 723 | make_symlink "$symlink_target" "$GIT_VALGRIND/bin/$base" || exit |
| 724 | } |
| 725 | |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 726 | # override all git executables in TEST_DIRECTORY/.. |
| 727 | GIT_VALGRIND=$TEST_DIRECTORY/valgrind |
| 728 | mkdir -p "$GIT_VALGRIND"/bin |
| 729 | for file in $GIT_BUILD_DIR/git* $GIT_BUILD_DIR/test-* |
| 730 | do |
| 731 | make_valgrind_symlink $file |
| 732 | done |
| 733 | # special-case the mergetools loadables |
| 734 | make_symlink "$GIT_BUILD_DIR"/mergetools "$GIT_VALGRIND/bin/mergetools" |
| 735 | OLDIFS=$IFS |
| 736 | IFS=: |
| 737 | for path in $PATH |
| 738 | do |
| 739 | ls "$path"/git-* 2> /dev/null | |
| 740 | while read file |
Johannes Schindelin | efd92ff | 2009-02-04 00:26:08 +0100 | [diff] [blame] | 741 | do |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 742 | make_valgrind_symlink "$file" |
Johannes Schindelin | efd92ff | 2009-02-04 00:26:08 +0100 | [diff] [blame] | 743 | done |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 744 | done |
| 745 | IFS=$OLDIFS |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 746 | PATH=$GIT_VALGRIND/bin:$PATH |
| 747 | GIT_EXEC_PATH=$GIT_VALGRIND/bin |
| 748 | export GIT_VALGRIND |
Thomas Rast | 952af35 | 2013-03-31 10:00:16 +0200 | [diff] [blame] | 749 | GIT_VALGRIND_MODE="$valgrind" |
| 750 | export GIT_VALGRIND_MODE |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 751 | GIT_VALGRIND_ENABLED=t |
Thomas Rast | 26a0730 | 2013-10-19 23:06:07 +0200 | [diff] [blame] | 752 | test -n "$valgrind_only" && GIT_VALGRIND_ENABLED= |
Thomas Rast | 5dfc368 | 2013-06-23 20:12:57 +0200 | [diff] [blame] | 753 | export GIT_VALGRIND_ENABLED |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 754 | elif test -n "$GIT_TEST_INSTALLED" |
| 755 | then |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 756 | GIT_EXEC_PATH=$($GIT_TEST_INSTALLED/git --exec-path) || |
| 757 | error "Cannot run git from $GIT_TEST_INSTALLED." |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 758 | PATH=$GIT_TEST_INSTALLED:$GIT_BUILD_DIR:$PATH |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 759 | GIT_EXEC_PATH=${GIT_TEST_EXEC_PATH:-$GIT_EXEC_PATH} |
| 760 | else # normal case, use ../bin-wrappers only unless $with_dashes: |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 761 | git_bin_dir="$GIT_BUILD_DIR/bin-wrappers" |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 762 | if ! test -x "$git_bin_dir/git" |
| 763 | then |
| 764 | if test -z "$with_dashes" |
| 765 | then |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 766 | say "$git_bin_dir/git is not executable; using GIT_EXEC_PATH" |
| 767 | fi |
| 768 | with_dashes=t |
| 769 | fi |
| 770 | PATH="$git_bin_dir:$PATH" |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 771 | GIT_EXEC_PATH=$GIT_BUILD_DIR |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 772 | if test -n "$with_dashes" |
| 773 | then |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 774 | PATH="$GIT_BUILD_DIR:$PATH" |
Matthew Ogilvie | e4597aa | 2009-12-02 22:14:06 -0700 | [diff] [blame] | 775 | fi |
Johannes Schindelin | 4e1be63 | 2009-02-04 00:25:59 +0100 | [diff] [blame] | 776 | fi |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 777 | GIT_TEMPLATE_DIR="$GIT_BUILD_DIR"/templates/blt |
Jeff King | 8bfa6bd | 2008-02-06 05:11:53 -0500 | [diff] [blame] | 778 | GIT_CONFIG_NOSYSTEM=1 |
Jonathan Nieder | 3c995be | 2011-03-15 04:05:10 -0500 | [diff] [blame] | 779 | GIT_ATTR_NOSYSTEM=1 |
Jonathan Nieder | 8f323c0 | 2011-03-15 04:04:49 -0500 | [diff] [blame] | 780 | export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_ATTR_NOSYSTEM |
Junio C Hamano | 49ccb08 | 2005-12-07 21:52:28 -0800 | [diff] [blame] | 781 | |
Junio C Hamano | 5e87eae | 2010-06-11 09:40:25 -0700 | [diff] [blame] | 782 | if test -z "$GIT_TEST_CMP" |
| 783 | then |
| 784 | if test -n "$GIT_TEST_CMP_USE_COPIED_CONTEXT" |
| 785 | then |
| 786 | GIT_TEST_CMP="$DIFF -c" |
| 787 | else |
| 788 | GIT_TEST_CMP="$DIFF -u" |
| 789 | fi |
| 790 | fi |
| 791 | |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 792 | GITPERLLIB="$GIT_BUILD_DIR"/perl/blib/lib:"$GIT_BUILD_DIR"/perl/blib/arch/auto/Git |
Petr Baudis | 6fcca93 | 2006-07-03 23:16:32 +0200 | [diff] [blame] | 793 | export GITPERLLIB |
Ævar Arnfjörð Bjarmason | 6cec5c6 | 2010-08-19 16:08:10 +0000 | [diff] [blame] | 794 | test -d "$GIT_BUILD_DIR"/templates/blt || { |
Junio C Hamano | eea4206 | 2005-12-10 20:55:32 -0800 | [diff] [blame] | 795 | error "You haven't built things yet, have you?" |
| 796 | } |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 797 | |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 798 | if ! test -x "$GIT_BUILD_DIR"/test-chmtime |
| 799 | then |
Eric Wong | 56cf980 | 2007-02-24 16:59:52 -0800 | [diff] [blame] | 800 | echo >&2 'You need to build test-chmtime:' |
| 801 | echo >&2 'Run "make test-chmtime" in the source (toplevel) directory' |
| 802 | exit 1 |
| 803 | fi |
| 804 | |
Junio C Hamano | e1970ce | 2005-05-13 22:50:32 -0700 | [diff] [blame] | 805 | # Test repository |
Jeff King | 002d4ce | 2013-04-14 15:38:21 -0400 | [diff] [blame] | 806 | TRASH_DIRECTORY="trash directory.$(basename "$0" .sh)" |
| 807 | test -n "$root" && TRASH_DIRECTORY="$root/$TRASH_DIRECTORY" |
| 808 | case "$TRASH_DIRECTORY" in |
| 809 | /*) ;; # absolute path is good |
| 810 | *) TRASH_DIRECTORY="$TEST_OUTPUT_DIRECTORY/$TRASH_DIRECTORY" ;; |
Jeff King | f423ef5 | 2009-08-09 04:39:45 -0400 | [diff] [blame] | 811 | esac |
Jeff King | 91c8b82 | 2009-08-09 04:38:11 -0400 | [diff] [blame] | 812 | test ! -z "$debug" || remove_trash=$TRASH_DIRECTORY |
John Keeping | 38b074d | 2013-04-14 17:34:56 +0100 | [diff] [blame] | 813 | rm -fr "$TRASH_DIRECTORY" || { |
Clemens Buchacher | 6e7b5aa | 2009-06-01 14:14:41 +0200 | [diff] [blame] | 814 | GIT_EXIT_OK=t |
Junio C Hamano | 8d14ac9 | 2008-03-18 21:58:01 -0700 | [diff] [blame] | 815 | echo >&5 "FATAL: Cannot prepare test area" |
| 816 | exit 1 |
| 817 | } |
| 818 | |
Alex Riesen | 90cff96 | 2011-03-26 19:46:34 +0100 | [diff] [blame] | 819 | HOME="$TRASH_DIRECTORY" |
| 820 | export HOME |
| 821 | |
Ramsay Jones | 1c0cc75 | 2012-09-01 19:11:49 +0100 | [diff] [blame] | 822 | if test -z "$TEST_NO_CREATE_REPO" |
| 823 | then |
John Keeping | 38b074d | 2013-04-14 17:34:56 +0100 | [diff] [blame] | 824 | test_create_repo "$TRASH_DIRECTORY" |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 825 | else |
John Keeping | 38b074d | 2013-04-14 17:34:56 +0100 | [diff] [blame] | 826 | mkdir -p "$TRASH_DIRECTORY" |
Thomas Rast | 342e9ef | 2012-02-17 11:25:09 +0100 | [diff] [blame] | 827 | fi |
Lea Wiemann | 1bd9c64 | 2008-05-31 23:11:21 +0200 | [diff] [blame] | 828 | # Use -P to resolve symlinks in our working directory so that the cwd |
| 829 | # in subprocesses like git equals our $PWD (for pathname comparisons). |
John Keeping | 38b074d | 2013-04-14 17:34:56 +0100 | [diff] [blame] | 830 | cd -P "$TRASH_DIRECTORY" || exit 1 |
Junio C Hamano | 04ece59 | 2006-12-28 17:58:00 -0800 | [diff] [blame] | 831 | |
Johannes Sixt | d5d9de1 | 2009-02-05 20:59:27 +0100 | [diff] [blame] | 832 | this_test=${0##*/} |
| 833 | this_test=${this_test%%-*} |
Thomas Rast | e6a6ddc | 2013-06-18 14:25:58 +0200 | [diff] [blame] | 834 | if match_pattern_list "$this_test" $GIT_SKIP_TESTS |
| 835 | then |
| 836 | say_color info >&3 "skipping test $this_test altogether" |
| 837 | skip_all="skip all tests in $this_test" |
| 838 | test_done |
| 839 | fi |
Johannes Sixt | f17e9fb | 2009-03-11 21:17:26 +0100 | [diff] [blame] | 840 | |
Brandon Casey | 8648732 | 2009-08-28 17:32:41 -0500 | [diff] [blame] | 841 | # Provide an implementation of the 'yes' utility |
| 842 | yes () { |
| 843 | if test $# = 0 |
| 844 | then |
| 845 | y=y |
| 846 | else |
| 847 | y="$*" |
| 848 | fi |
| 849 | |
| 850 | while echo "$y" |
| 851 | do |
| 852 | : |
| 853 | done |
| 854 | } |
| 855 | |
Johannes Sixt | f17e9fb | 2009-03-11 21:17:26 +0100 | [diff] [blame] | 856 | # Fix some commands on Windows |
| 857 | case $(uname -s) in |
| 858 | *MINGW*) |
| 859 | # Windows has its own (incompatible) sort and find |
| 860 | sort () { |
| 861 | /usr/bin/sort "$@" |
| 862 | } |
| 863 | find () { |
| 864 | /usr/bin/find "$@" |
| 865 | } |
Johannes Sixt | 5397ea3 | 2009-03-14 22:21:27 +0100 | [diff] [blame] | 866 | sum () { |
| 867 | md5sum "$@" |
| 868 | } |
Johannes Sixt | 4114156 | 2009-03-13 23:35:24 +0100 | [diff] [blame] | 869 | # git sees Windows-style pwd |
| 870 | pwd () { |
| 871 | builtin pwd -W |
| 872 | } |
Johannes Sixt | ee9fb68 | 2009-03-13 22:55:27 +0100 | [diff] [blame] | 873 | # no POSIX permissions |
Johannes Sixt | 6fd1106 | 2009-03-13 23:00:15 +0100 | [diff] [blame] | 874 | # backslashes in pathspec are converted to '/' |
Johannes Sixt | fb9a2be | 2009-03-25 13:21:15 +0100 | [diff] [blame] | 875 | # exec does not inherit the PID |
Pat Thoyts | a94114a | 2010-09-12 10:37:24 +0100 | [diff] [blame] | 876 | test_set_prereq MINGW |
Pete Wyckoff | cfa9649 | 2013-01-26 22:11:11 -0500 | [diff] [blame] | 877 | test_set_prereq NOT_CYGWIN |
Ramsay Jones | a31d066 | 2010-12-14 18:32:12 +0000 | [diff] [blame] | 878 | test_set_prereq SED_STRIPS_CR |
Mark Levedahl | 97669ee | 2013-07-18 17:44:57 -0400 | [diff] [blame] | 879 | test_set_prereq GREP_STRIPS_CR |
Johannes Sixt | 4d715ac | 2013-10-26 21:17:15 +0200 | [diff] [blame] | 880 | GIT_TEST_CMP=mingw_test_cmp |
Ramsay Jones | a31d066 | 2010-12-14 18:32:12 +0000 | [diff] [blame] | 881 | ;; |
| 882 | *CYGWIN*) |
| 883 | test_set_prereq POSIXPERM |
Ramsay Jones | a31d066 | 2010-12-14 18:32:12 +0000 | [diff] [blame] | 884 | test_set_prereq EXECKEEPSPID |
| 885 | test_set_prereq NOT_MINGW |
Pete Wyckoff | cfa9649 | 2013-01-26 22:11:11 -0500 | [diff] [blame] | 886 | test_set_prereq CYGWIN |
Ramsay Jones | a31d066 | 2010-12-14 18:32:12 +0000 | [diff] [blame] | 887 | test_set_prereq SED_STRIPS_CR |
Mark Levedahl | 97669ee | 2013-07-18 17:44:57 -0400 | [diff] [blame] | 888 | test_set_prereq GREP_STRIPS_CR |
Johannes Sixt | ee9fb68 | 2009-03-13 22:55:27 +0100 | [diff] [blame] | 889 | ;; |
| 890 | *) |
| 891 | test_set_prereq POSIXPERM |
Johannes Sixt | 6fd1106 | 2009-03-13 23:00:15 +0100 | [diff] [blame] | 892 | test_set_prereq BSLASHPSPEC |
Johannes Sixt | fb9a2be | 2009-03-25 13:21:15 +0100 | [diff] [blame] | 893 | test_set_prereq EXECKEEPSPID |
Pat Thoyts | 3ba9ba8 | 2010-09-27 22:02:57 +0100 | [diff] [blame] | 894 | test_set_prereq NOT_MINGW |
Pete Wyckoff | cfa9649 | 2013-01-26 22:11:11 -0500 | [diff] [blame] | 895 | test_set_prereq NOT_CYGWIN |
Johannes Sixt | f17e9fb | 2009-03-11 21:17:26 +0100 | [diff] [blame] | 896 | ;; |
| 897 | esac |
Johannes Sixt | 704a314 | 2009-03-04 22:38:24 +0100 | [diff] [blame] | 898 | |
Zbigniew Jędrzejewski-Szmek | b082687 | 2012-04-27 11:25:25 +0200 | [diff] [blame] | 899 | ( COLUMNS=1 && test $COLUMNS = 1 ) && test_set_prereq COLUMNS_CAN_BE_1 |
Jeff King | 1b19ccd | 2009-04-03 15:33:59 -0400 | [diff] [blame] | 900 | test -z "$NO_PERL" && test_set_prereq PERL |
Johan Herland | d4e1b47 | 2009-11-18 02:42:31 +0100 | [diff] [blame] | 901 | test -z "$NO_PYTHON" && test_set_prereq PYTHON |
Michał Kiedrowicz | 8f852ce | 2011-05-09 23:52:07 +0200 | [diff] [blame] | 902 | test -n "$USE_LIBPCRE" && test_set_prereq LIBPCRE |
Ævar Arnfjörð Bjarmason | 5e9637c | 2011-11-18 00:14:42 +0100 | [diff] [blame] | 903 | test -z "$NO_GETTEXT" && test_set_prereq GETTEXT |
Jeff King | 1b19ccd | 2009-04-03 15:33:59 -0400 | [diff] [blame] | 904 | |
Ævar Arnfjörð Bjarmason | bb946bb | 2011-02-22 23:41:21 +0000 | [diff] [blame] | 905 | # Can we rely on git's output in the C locale? |
Jonathan Nieder | 3095522 | 2011-02-22 23:41:22 +0000 | [diff] [blame] | 906 | if test -n "$GETTEXT_POISON" |
| 907 | then |
| 908 | GIT_GETTEXT_POISON=YesPlease |
| 909 | export GIT_GETTEXT_POISON |
Ævar Arnfjörð Bjarmason | 5e9637c | 2011-11-18 00:14:42 +0100 | [diff] [blame] | 910 | test_set_prereq GETTEXT_POISON |
Jonathan Nieder | 3095522 | 2011-02-22 23:41:22 +0000 | [diff] [blame] | 911 | else |
| 912 | test_set_prereq C_LOCALE_OUTPUT |
| 913 | fi |
Ævar Arnfjörð Bjarmason | bb946bb | 2011-02-22 23:41:21 +0000 | [diff] [blame] | 914 | |
Junio C Hamano | cabdee2 | 2011-04-12 11:23:23 -0700 | [diff] [blame] | 915 | # Use this instead of test_cmp to compare files that contain expected and |
| 916 | # actual output from git commands that can be translated. When running |
| 917 | # under GETTEXT_POISON this pretends that the command produced expected |
| 918 | # results. |
| 919 | test_i18ncmp () { |
| 920 | test -n "$GETTEXT_POISON" || test_cmp "$@" |
| 921 | } |
| 922 | |
Junio C Hamano | 127df8c | 2011-04-12 15:57:08 -0700 | [diff] [blame] | 923 | # Use this instead of "grep expected-string actual" to see if the |
| 924 | # output from a git command that can be translated either contains an |
| 925 | # expected string, or does not contain an unwanted one. When running |
| 926 | # under GETTEXT_POISON this pretends that the command produced expected |
| 927 | # results. |
| 928 | test_i18ngrep () { |
| 929 | if test -n "$GETTEXT_POISON" |
| 930 | then |
| 931 | : # pretend success |
| 932 | elif test "x!" = "x$1" |
| 933 | then |
| 934 | shift |
| 935 | ! grep "$@" |
| 936 | else |
| 937 | grep "$@" |
| 938 | fi |
| 939 | } |
| 940 | |
Adam Spiers | 2007327 | 2013-04-11 03:07:04 +0100 | [diff] [blame] | 941 | test_lazy_prereq PIPE ' |
| 942 | # test whether the filesystem supports FIFOs |
Mark Levedahl | 9443605 | 2013-07-04 18:04:30 -0400 | [diff] [blame] | 943 | case $(uname -s) in |
| 944 | CYGWIN*) |
| 945 | false |
| 946 | ;; |
| 947 | *) |
| 948 | rm -f testfifo && mkfifo testfifo |
| 949 | ;; |
| 950 | esac |
Adam Spiers | 2007327 | 2013-04-11 03:07:04 +0100 | [diff] [blame] | 951 | ' |
| 952 | |
Junio C Hamano | 04083f2 | 2012-07-26 15:50:45 -0700 | [diff] [blame] | 953 | test_lazy_prereq SYMLINKS ' |
| 954 | # test whether the filesystem supports symbolic links |
| 955 | ln -s x y && test -h y |
| 956 | ' |
Ævar Arnfjörð Bjarmason | c91cfd1 | 2010-08-06 22:09:09 +0000 | [diff] [blame] | 957 | |
Jonathan Nieder | b018c73 | 2013-11-25 13:02:16 -0800 | [diff] [blame] | 958 | test_lazy_prereq FILEMODE ' |
| 959 | test "$(git config --bool core.filemode)" = true |
| 960 | ' |
| 961 | |
Michael J Gruber | ac39aa6 | 2012-07-26 15:39:53 +0200 | [diff] [blame] | 962 | test_lazy_prereq CASE_INSENSITIVE_FS ' |
| 963 | echo good >CamelCase && |
| 964 | echo bad >camelcase && |
| 965 | test "$(cat CamelCase)" != good |
| 966 | ' |
| 967 | |
Michael J Gruber | 5b0b5dd | 2012-07-26 15:39:56 +0200 | [diff] [blame] | 968 | test_lazy_prereq UTF8_NFD_TO_NFC ' |
| 969 | # check whether FS converts nfd unicode to nfc |
| 970 | auml=$(printf "\303\244") |
| 971 | aumlcdiar=$(printf "\141\314\210") |
| 972 | >"$auml" && |
| 973 | case "$(echo *)" in |
| 974 | "$aumlcdiar") |
| 975 | true ;; |
| 976 | *) |
| 977 | false ;; |
| 978 | esac |
| 979 | ' |
| 980 | |
Jeff King | 09feffb | 2012-11-14 16:33:40 -0800 | [diff] [blame] | 981 | test_lazy_prereq AUTOIDENT ' |
| 982 | sane_unset GIT_AUTHOR_NAME && |
| 983 | sane_unset GIT_AUTHOR_EMAIL && |
| 984 | git var GIT_AUTHOR_IDENT |
| 985 | ' |
| 986 | |
Junio C Hamano | 6219bb2 | 2014-06-09 12:23:30 -0700 | [diff] [blame] | 987 | test_lazy_prereq EXPENSIVE ' |
| 988 | test -n "$GIT_TEST_LONG" |
| 989 | ' |
| 990 | |
Junio C Hamano | e1ecd9e | 2014-06-09 13:54:25 -0700 | [diff] [blame] | 991 | test_lazy_prereq USR_BIN_TIME ' |
| 992 | test -x /usr/bin/time |
| 993 | ' |
| 994 | |
Jeff King | 1767c51 | 2015-01-16 04:16:49 -0500 | [diff] [blame] | 995 | test_lazy_prereq NOT_ROOT ' |
| 996 | uid=$(id -u) && |
| 997 | test "$uid" != 0 |
| 998 | ' |
| 999 | |
Torsten Bögershausen | f400e51 | 2015-01-27 16:39:01 +0100 | [diff] [blame^] | 1000 | # On a filesystem that lacks SANITY, a file can be deleted even if |
| 1001 | # the containing directory doesn't have write permissions, or a file |
| 1002 | # can be accessed even if the containing directory doesn't have read |
| 1003 | # or execute permissions, causing our tests that validate that Git |
| 1004 | # works sensibly in such situations. |
| 1005 | test_lazy_prereq SANITY ' |
| 1006 | mkdir SANETESTD.1 SANETESTD.2 && |
| 1007 | |
| 1008 | chmod +w SANETESTD.1 SANETESTD.2 && |
| 1009 | >SANETESTD.1/x 2>SANETESTD.2/x && |
| 1010 | chmod -w SANETESTD.1 && |
| 1011 | chmod -rx SANETESTD.2 || |
| 1012 | error "bug in test sript: cannot prepare SANETESTD" |
| 1013 | |
| 1014 | ! rm SANETESTD.1/x && ! test -f SANETESTD.2/x |
| 1015 | status=$? |
| 1016 | |
| 1017 | chmod +rwx SANETESTD.1 SANETESTD.2 && |
| 1018 | rm -rf SANETESTD.1 SANETESTD.2 || |
| 1019 | error "bug in test sript: cannot clean SANETESTD" |
| 1020 | return $status |
| 1021 | ' |
Jeff King | f838ce5 | 2013-03-10 21:31:47 -0400 | [diff] [blame] | 1022 | |
| 1023 | GIT_UNZIP=${GIT_UNZIP:-unzip} |
| 1024 | test_lazy_prereq UNZIP ' |
| 1025 | "$GIT_UNZIP" -v |
| 1026 | test $? -ne 127 |
| 1027 | ' |